window.Gleam.initSearch([{"doc":"glitr_lustre","title":"glitr_lustre","content":"# glitr_lustre\r\n\r\nInterface for lustre to use Glitr&#39;s typed routes\r\n\r\n[![Package Version](https://img.shields.io/hexpm/v/glitr_lustre)](https://hex.pm/packages/glitr_lustre)\r\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/glitr_lustre/)\r\n\r\n```sh\r\ngleam add glitr_lustre\r\n```\r\n```gleam\r\nimport glitr_lustre\r\nimport lustre\r\n\r\npub fn main() {\r\n  let app = lustre.application(init, update, view)\r\n  let assert Ok(_) = lustre.start(app, &quot;#app&quot;, Nil)\r\n\r\n  Nil\r\n}\r\n\r\nfn update(model: Model, msg: Msg) -&gt; #(Model, Effect(Msg)) {\r\n  case msg {\r\n    TodoAdded(title) -&gt; #(model, glitr_lustre.send_to_route(\r\n      todo_routes.create(),\r\n      Nil,\r\n      CreateTodo(title),\r\n      ServerCreatedTodo,\r\n    ))\r\n    ServerCreatedTodo(Ok(new_todo)) -&gt; #([new_todo, ..model], effect.none())\r\n    _ -&gt; #(model, effect.none())\r\n  }\r\n}\r\n```\r\n\r\nFurther documentation can be found at &lt;https://hexdocs.pm/glitr_lustre&gt;.\r\n\r\n## Development\r\n\r\n```sh\r\ngleam run   # Run the project\r\ngleam test  # Run the tests\r\n```\r\n","url":"index.html"},{"doc":"glitr_lustre","title":"RequestFactory","content":"pub type RequestFactory {\n  RequestFactory(scheme: http.Scheme, host: String, port: Int)\n}\n\nRequestFactory(scheme: http.Scheme, host: String, port: Int)\n\n\nSynonyms:\nglitr_lustre.RequestFactory\nglitr_lustre RequestFactory","url":"glitr_lustre.html#RequestFactory"},{"doc":"glitr_lustre","title":"RouteRequest","content":"pub type RouteRequest(p, q, b, c) {\n  RouteRequest(\n    route: route.Route(p, q, b, c),\n    scheme: http.Scheme,\n    host: String,\n    port: Int,\n    path_opt: Option(p),\n    query_opt: Option(q),\n    body_opt: Option(b),\n  )\n}\n\nRouteRequest(\n  route: route.Route(p, q, b, c),\n  scheme: http.Scheme,\n  host: String,\n  port: Int,\n  path_opt: Option(p),\n  query_opt: Option(q),\n  body_opt: Option(b),\n)\n\n\nSynonyms:\nglitr_lustre.RouteRequest\nglitr_lustre RouteRequest","url":"glitr_lustre.html#RouteRequest"},{"doc":"glitr_lustre","title":"create_factory","content":"pub fn create_factory() -&gt; RequestFactory\n\nSynonyms:\nglitr_lustre.create_factory\nglitr_lustre create_factory","url":"glitr_lustre.html#create_factory"},{"doc":"glitr_lustre","title":"for_route","content":"pub fn for_route(\n  factory: RequestFactory,\n  route: Route(a, b, c, d),\n) -&gt; RouteRequest(a, b, c, d)\n\nSynonyms:\nglitr_lustre.for_route\nglitr_lustre for_route","url":"glitr_lustre.html#for_route"},{"doc":"glitr_lustre","title":"send","content":"pub fn send(\n  rreq: RouteRequest(a, b, c, d),\n  as_msg: fn(Result(d, HttpError)) -&gt; e,\n  on_error: fn(String) -&gt; Effect(e),\n) -&gt; Effect(e)\n\nSynonyms:\nglitr_lustre.send\nglitr_lustre send","url":"glitr_lustre.html#send"},{"doc":"glitr_lustre","title":"with_body","content":"pub fn with_body(\n  request: RouteRequest(a, b, c, d),\n  body: c,\n) -&gt; RouteRequest(a, b, c, d)\n\nSynonyms:\nglitr_lustre.with_body\nglitr_lustre with_body","url":"glitr_lustre.html#with_body"},{"doc":"glitr_lustre","title":"with_host","content":"pub fn with_host(\n  factory: RequestFactory,\n  host: String,\n) -&gt; RequestFactory\n\nSynonyms:\nglitr_lustre.with_host\nglitr_lustre with_host","url":"glitr_lustre.html#with_host"},{"doc":"glitr_lustre","title":"with_options","content":"pub fn with_options(\n  request: RouteRequest(a, b, c, d),\n  options: RouteOptions(a, b, c),\n) -&gt; RouteRequest(a, b, c, d)\n\nSynonyms:\nglitr_lustre.with_options\nglitr_lustre with_options","url":"glitr_lustre.html#with_options"},{"doc":"glitr_lustre","title":"with_path","content":"pub fn with_path(\n  request: RouteRequest(a, b, c, d),\n  path: a,\n) -&gt; RouteRequest(a, b, c, d)\n\nSynonyms:\nglitr_lustre.with_path\nglitr_lustre with_path","url":"glitr_lustre.html#with_path"},{"doc":"glitr_lustre","title":"with_port","content":"pub fn with_port(\n  factory: RequestFactory,\n  port: Int,\n) -&gt; RequestFactory\n\nSynonyms:\nglitr_lustre.with_port\nglitr_lustre with_port","url":"glitr_lustre.html#with_port"},{"doc":"glitr_lustre","title":"with_query","content":"pub fn with_query(\n  request: RouteRequest(a, b, c, d),\n  query: b,\n) -&gt; RouteRequest(a, b, c, d)\n\nSynonyms:\nglitr_lustre.with_query\nglitr_lustre with_query","url":"glitr_lustre.html#with_query"},{"doc":"glitr_lustre","title":"with_scheme","content":"pub fn with_scheme(\n  factory: RequestFactory,\n  scheme: Scheme,\n) -&gt; RequestFactory\n\nSynonyms:\nglitr_lustre.with_scheme\nglitr_lustre with_scheme","url":"glitr_lustre.html#with_scheme"},{"doc":"glitr_lustre","title":"glitr_lustre","content":"","url":"glitr_lustre.html"}]);